﻿Imports System.Text
Imports LuxSciWebApiWrapperVB
Imports Microsoft.VisualStudio.TestTools.UnitTesting


<TestClass>
Public Class LuxSciApiWrapperTest
    <TestMethod>
    Public Sub GetAuthenticationTest()
        Dim authApi As AuthApiWrapper = New AuthApiWrapper()
        Dim authCodeTask As Task(Of String) = authApi.GetAuthenticationToken()
        authCodeTask.Wait()
        Assert.IsFalse(String.IsNullOrEmpty(authCodeTask.Result))
    End Sub

    <TestMethod>
    Public Sub GetUserProfileTest()
        Dim userApi As UserApiWrapper = New UserApiWrapper()
        Dim userProfileTask As Task(Of UserProfile) = userApi.GetUserProfile()
        userProfileTask.Wait()
        Dim userProfile = TryCast(userProfileTask.Result, UserProfile)
        Assert.IsTrue(userProfile IsNot Nothing)
    End Sub

    <TestMethod>
    Public Sub SendMailTest()
        Dim userApi As UserApiWrapper = New UserApiWrapper()
        Dim emailRequest As EmailRequest = New EmailRequest()
        emailRequest.Subject = "Hello, test message"
        emailRequest.Body = "Dear User " & vbLf & " This is a test message for you from LuxSci, using amazing APIs. " & vbLf & " Regards " & vbLf & " LuxSciTeam"
        emailRequest.[To] = New String() {"sakthirvin@gmail.com"}
        emailRequest.FromName = "Sakthi Ramesh Kumar C"
        emailRequest.FromAddress = "admin@csharpapi.trial6.luxsci.net"
        emailRequest.BodyType = "text"
        Dim sendMailTask = userApi.SendMail(emailRequest)
        sendMailTask.Wait()
        Assert.IsTrue(sendMailTask.Result)
    End Sub

    <TestMethod>
    Public Sub SendMailWithAttachmentTest()
        Dim userApi As UserApiWrapper = New UserApiWrapper()
        Dim emailRequest As EmailRequest = New EmailRequest()
        emailRequest.Subject = "Hello, test message"
        emailRequest.Body = "Dear User " & vbLf & " This is a test message for you from LuxSci, using amazing APIs. " & vbLf & " Regards " & vbLf & " LuxSciTeam"
        emailRequest.[To] = New String() {"sakthirvin@gmail.com"}
        emailRequest.FromName = "Sakthi Ramesh Kumar C"
        emailRequest.FromAddress = "admin@csharpapi.trial6.luxsci.net"
        emailRequest.BodyType = "text"
        Dim sendMailTask = userApi.SendMailWithAttachment(emailRequest, "D:\WorkingFolder\LuxAPI\Documents\LuxSci_API_General.pdf")
        sendMailTask.Wait()
        Assert.IsTrue(sendMailTask.Result)
    End Sub

    <TestMethod>
    Public Sub GetEmailSentReportTest()
        Dim userApi As UserApiWrapper = New UserApiWrapper()
        Dim mailSentReportTask As Task(Of String) = userApi.GetMailSentReport()
        mailSentReportTask.Wait()
        Dim report = TryCast(mailSentReportTask.Result, String)
        Assert.IsTrue(report IsNot Nothing)
    End Sub

    <TestMethod>
    Public Sub GetAccountAuthenticationTokenTest()
        Dim authApi As AuthApiWrapper = New AuthApiWrapper()
        Dim authCodeTask As Task(Of String) = authApi.GetAccountAuthenticationToken()
        authCodeTask.Wait()
        Assert.IsFalse(String.IsNullOrEmpty(authCodeTask.Result))
    End Sub

    <TestMethod>
    Public Sub GetAccountProfileTest()
        Dim accountApi As AccountApiWrapper = New AccountApiWrapper()
        Dim accountProfileTask As Task(Of String) = accountApi.GetAccountProfile()
        accountProfileTask.Wait()
        Dim profile = TryCast(accountProfileTask.Result, String)
        Assert.IsTrue(profile IsNot Nothing)
    End Sub

    <TestMethod>
    Public Sub CreateAliasTest()
        Dim accountApi As AccountApiWrapper = New AccountApiWrapper()
        Dim [alias] As AliasRequest = New AliasRequest() With {
            .User = "JohnDoe",
            .Action = "bounce",
            .Domain = "demouser@test.trial6.luxsci.net",
            .Dest = "demouser@test.trial6.luxsci.net",
            .Bounce = "xxxx@gmail.com"
        }
        Dim createAliasTask As Task(Of Boolean) = accountApi.CreateAlias([alias])
        createAliasTask.Wait()
        Assert.IsTrue(createAliasTask.Result)
    End Sub

    <TestMethod>
    Public Sub GetAccountEmailSentReportTest()
        Dim accountApi As AccountApiWrapper = New AccountApiWrapper()
        Dim mailSentReportTask As Task(Of String) = accountApi.GetMailSentReport(EmailType.SMTP)
        mailSentReportTask.Wait()
        Dim report = TryCast(mailSentReportTask.Result, String)
        Assert.IsTrue(report IsNot Nothing)
    End Sub

    <TestMethod>
    Public Sub GetAccountWebEmailSentReportTest()
        Dim accountApi As AccountApiWrapper = New AccountApiWrapper()
        Dim mailSentReportTask As Task(Of String) = accountApi.GetMailSentReport(EmailType.WebMail)
        mailSentReportTask.Wait()
        Dim report = TryCast(mailSentReportTask.Result, String)
        Assert.IsTrue(report IsNot Nothing)
    End Sub
End Class
